/*
EntryPoints

## Overview  EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.  ## Data  EntryPoints contain two types of data:   - **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction) - **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.  Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.  ## EP Batches  EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.  > EntryPoints in a batch have random hashes but it's possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).  EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).  ## Redirects  There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package entrypoints

import (
	"encoding/json"
)

// checks if the GenericResponseErrors type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GenericResponseErrors{}

// GenericResponseErrors struct for GenericResponseErrors
type GenericResponseErrors struct {
	Field string `json:"field"`
	Message *string `json:"message,omitempty"`
	Code *string `json:"code,omitempty"`
	Param *string `json:"param,omitempty"`
}

// NewGenericResponseErrors instantiates a new GenericResponseErrors object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGenericResponseErrors(field string) *GenericResponseErrors {
	this := GenericResponseErrors{}
	this.Field = field
	return &this
}

// NewGenericResponseErrorsWithDefaults instantiates a new GenericResponseErrors object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGenericResponseErrorsWithDefaults() *GenericResponseErrors {
	this := GenericResponseErrors{}
	return &this
}

// GetField returns the Field field value
func (o *GenericResponseErrors) GetField() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Field
}

// GetFieldOk returns a tuple with the Field field value
// and a boolean to check if the value has been set.
func (o *GenericResponseErrors) GetFieldOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Field, true
}

// SetField sets field value
func (o *GenericResponseErrors) SetField(v string) {
	o.Field = v
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *GenericResponseErrors) GetMessage() string {
	if o == nil || IsNil(o.Message) {
		var ret string
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GenericResponseErrors) GetMessageOk() (*string, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *GenericResponseErrors) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given string and assigns it to the Message field.
func (o *GenericResponseErrors) SetMessage(v string) {
	o.Message = &v
}

// GetCode returns the Code field value if set, zero value otherwise.
func (o *GenericResponseErrors) GetCode() string {
	if o == nil || IsNil(o.Code) {
		var ret string
		return ret
	}
	return *o.Code
}

// GetCodeOk returns a tuple with the Code field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GenericResponseErrors) GetCodeOk() (*string, bool) {
	if o == nil || IsNil(o.Code) {
		return nil, false
	}
	return o.Code, true
}

// HasCode returns a boolean if a field has been set.
func (o *GenericResponseErrors) HasCode() bool {
	if o != nil && !IsNil(o.Code) {
		return true
	}

	return false
}

// SetCode gets a reference to the given string and assigns it to the Code field.
func (o *GenericResponseErrors) SetCode(v string) {
	o.Code = &v
}

// GetParam returns the Param field value if set, zero value otherwise.
func (o *GenericResponseErrors) GetParam() string {
	if o == nil || IsNil(o.Param) {
		var ret string
		return ret
	}
	return *o.Param
}

// GetParamOk returns a tuple with the Param field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GenericResponseErrors) GetParamOk() (*string, bool) {
	if o == nil || IsNil(o.Param) {
		return nil, false
	}
	return o.Param, true
}

// HasParam returns a boolean if a field has been set.
func (o *GenericResponseErrors) HasParam() bool {
	if o != nil && !IsNil(o.Param) {
		return true
	}

	return false
}

// SetParam gets a reference to the given string and assigns it to the Param field.
func (o *GenericResponseErrors) SetParam(v string) {
	o.Param = &v
}

func (o GenericResponseErrors) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GenericResponseErrors) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["field"] = o.Field
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	if !IsNil(o.Code) {
		toSerialize["code"] = o.Code
	}
	if !IsNil(o.Param) {
		toSerialize["param"] = o.Param
	}
	return toSerialize, nil
}

type NullableGenericResponseErrors struct {
	value *GenericResponseErrors
	isSet bool
}

func (v NullableGenericResponseErrors) Get() *GenericResponseErrors {
	return v.value
}

func (v *NullableGenericResponseErrors) Set(val *GenericResponseErrors) {
	v.value = val
	v.isSet = true
}

func (v NullableGenericResponseErrors) IsSet() bool {
	return v.isSet
}

func (v *NullableGenericResponseErrors) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGenericResponseErrors(val *GenericResponseErrors) *NullableGenericResponseErrors {
	return &NullableGenericResponseErrors{value: val, isSet: true}
}

func (v NullableGenericResponseErrors) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGenericResponseErrors) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


